﻿using Syncfusion.Pdf.Parsing;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Syncfusion.Pdf;
using Syncfusion.Pdf.Graphics;
using System.Threading.Tasks;
using System.Drawing;

namespace PdfFormASP
{
    public partial class _Default : Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

        }

        protected void Button1_Click(object sender, EventArgs e)
        {
            

            string baseName = "Test";
            List<Task> tasks = new List<Task>();

            ////spin up 10 parallel tasks 
            ////the error also occurs when creating a PDF file directly
            for (int i = 0; i < 10; i++)
            {
                //capture the current count in a closure
                int num = i;
                ConvertFile(baseName, i);
                tasks.Add(Task.Factory.StartNew(() => ConvertFile(baseName, num)));
            }

            ////wait for all tasks to complete
            Task.WaitAll(tasks.ToArray());

        }

        private void ConvertFile(string baseName, int num)
        {
            PdfDocument doc = new PdfDocument();
            PdfDocument.EnableCache = false;
            PdfPage page = doc.Pages.Add();

            PdfFont font = new PdfTrueTypeFont(new Font("Arial", 36), true);
          
            PdfGraphics g = page.Graphics;
            PdfGraphicsState state = g.Save();
            g.SetTransparency(0.25f);
            g.RotateTransform(-40);
            g.DrawString("Water mark drawing", font, PdfPens.Red, PdfBrushes.Red, new PointF(-150, 450));


            doc.Save(Server.MapPath("~/Output/"+"proceeed-" + num + ".pdf"));
            doc.Close(true);

        }
    }
}